import sys, getopt
import os
from os import listdir
from os.path import isfile, join
from pathlib import Path
import os.path
from os import path
from ete3 import Tree
import platform
import DART_prep_NEW

#import time
#start_time = time.time()


TransferCostArg1 = 3
TransferCostArg2 = 4
#allowed), '-d', str(immediateGenes), '-e', str(EachSide)])
allowed = 1
immediateGenes = 2
EachSide = 4

XArg = 2
YArg = 3
ZArg = 3
RareGenesfile = ''
TransferSupport_HMGT = 10
TransferSupport_HGT = 100
mapping = 51

def main(argv):
    arg_parsing(argv)
def arg_parsing(argv):
    genefile = ''
    speciesTreefile = ''
    genomesFile = ''
    toSaveFolder = ''
    global TransferCostArg1
    global TransferCostArg2
    global XArg
    global YArg
    global ZArg
    global RareGenesfile
    global TransferSupport_HMGT
    global TransferSupport_HGT
    global mapping
    global allowed
    global immediateGenes
    global EachSide

    try:
        opts, args = getopt.getopt(argv,"hg:s:n:c:r:f:x:y:z:k:u:m:i:d:e:",["gfile=","sfile=","genomes=","transfer1=","transfer2=","toSave=","Xarg=","Yarg=","Zarg=","Rare=","transSupport2=","mapping=","allowed=", "numImm=", "EachSide="])
    except getopt.GetoptError:
        print('Error: DART_Aggregate.py Required parameters: -g <Path to the directory containing the rooted gene trees> -s <Rooted species tree> -n <Path to the directory containing gene ordering (synteny) files.> -f <Path to a directory to save the results> ')
        sys.exit(2)
    for opt, arg in opts:
        if opt == '-h':
            print('-g \t Path to directory containing the rooted gene trees in Newick format. This is a required \n \t parameter. \n ')
            print('-s \t Rooted species tree. This is a required parameter.\n ')
            print('-n \t Path to the directory containing gene ordering (synteny) files. This is a required \n \t parameter. \n')
            print('-f \t Path to an empty directory to save output files. This is a required parameter. \n')
            print('-c \t Permissive transfer cost to use when computing phylogenetic reconciliations. Defaults \n \t to 3. Must be a natural number. \n')
            print('-r \t Restrictive transfer cost to use when computing phylogenetic reconciliations. Defaults \n \t to 4. Must be a natural number, and greater than the permissive transfer cost.\n')
            print('-e \t Number of neighboring genes to consider on each side of the transferred gene when \n \t calculating conservation of genomic context. Defaults to 4. \n')
            print('-d \t Number of closest neighboring genes on each side of the transferred gene to consider \n \t for HMGT filtering. Any inferred HGTs for which any of these immediate genes are HGTs \n \t from the same donor (or rare genes, if a rare gene list is provided) are filtered out as \n \t potential horizontal multi-gene transfers. Defaults to 2.\n')
            print('-i \t Maximum number of HGTs from the same donor (or rare genes, if a rare gene is \n \t provided) allowed in the set of genes neighboring the transferred gene. Default to 1; \n \t i.e., if the genes neighboring the transferred gene (as specified using the -e option) have \n \t 2 or more HGTs from the same donor then that transferred gene is filtered out as \n \t belonging to a possible HMGT. \n')
            #print('Optional parameter: -t <Confidence threshold for inferring transfer events in HMGTs that will be used with the two transfer costs. \n \t Must be between 1 and 100. Defaults to 10. >')
            print('-u \t Confidence threshold for inferring high-confidence leaf-to-leaf HGTs (using the \n \t restrictive transfer cost). Must be between 1 and 100. Defaults to 100. \n')
            print('-m \t Mapping confidence threshold for HGTs. Must be between 51 and 100. Defaults to 51. \n')
            print('-k \t File containing list of rare genes. Default is to assume no rare genes. \n')
            print('-h \t Output this help message. \n')
            
            sys.exit()
        elif opt in ("-g", "--gfile"):
            genefile = arg
        elif opt in ("-s", "--sfile"):
            speciesTreefile = arg
        elif opt in ("-n", "--genomes"):
            genomesFile = arg
        elif opt in ("-f", "--toSave"):
            toSaveFolder = arg
        elif opt in ("-c", "--transfer1"):
            TransferCostArg1 = arg
        elif opt in ("-r", "--transfer2"):
            TransferCostArg2 = arg
        elif opt in ("-x", "--Xarg"):
            XArg = arg
        elif opt in ("-y", "--Yarg"):
            YArg = arg
        elif opt in ("-z", "--Zarg"):
            ZArg = arg
        elif opt in ("-k", "--Rare"):
            RareGenesfile = arg
        elif opt in ("-t", "--transSupport1"):
            TransferSupport_HMGT = arg
        elif opt in ("-u", "--transSupport2"):
            TransferSupport_HGT = arg
        elif opt in ("-m", "--mapping"):
            mapping = arg
        elif opt in ("-i", "--allowed"):
            allowed = arg
        elif opt in ("-d", "--numImm"):
            immediateGenes = arg
        elif opt in ("-e", "--EachSide"):
            EachSide = arg
        
    NoEx = ''   
    executeFlag = ''
    if genefile != None and genefile != '' and speciesTreefile != None and speciesTreefile != '' and genomesFile != None and genomesFile != '' and toSaveFolder != None and toSaveFolder != '':
        if (os.path.exists(genefile) and os.path.exists(speciesTreefile) and os.path.exists(genomesFile) and os.path.exists(toSaveFolder)):
            executeFlag = 'true'
        else:
            print('Required parameter: -g <Path to the directory containing the rooted gene trees> -s <Rooted species tree> -n <Path to the directory containing gene ordering (synteny) files.> -f <Path to a directory to save the results> ')
            NoEx = 'f'
    else:
        print('Required parameter: -g <Path to the directory containing the rooted gene trees> -s <Rooted species tree> -n <Path to the directory containing gene ordering (synteny) files.> -f <Path to a directory to save the results> ')
        NoEx = 'f'
    ## 1st transfer cost , HMGTs
    if TransferCostArg1 != None and TransferCostArg1 != '':
        if int(TransferCostArg1) > 0:
            executeFlag = 'true'
        else:
            print('-c First transfer cost to use when computing phylogenetic reconciliations. Defaults to 3. Must be a natural number.')
            NoEx = 'f'
    else:
        print('-c First transfer cost to use when computing phylogenetic reconciliations. Defaults to 3. Must be a natural number.')
        NoEx = 'f'
    #2nd Transfer cost , HGT
    if TransferCostArg2 != None and TransferCostArg2 != '':
        if int(TransferCostArg2) > 0 and int(TransferCostArg2) > int(TransferCostArg1):
            executeFlag = 'true'
        else:
            print('-d Second transfer cost to use when computing phylogenetic reconciliations. Defaults to 4. \n \t Must be a natural number, and greater than the first transfer cost.')
            NoEx = 'f'
    else:
        print('-d Second transfer cost to use when computing phylogenetic reconciliations. Defaults to 4. \n \t Must be a natural number, and greater than the first transfer cost.')
        NoEx = 'f'

    #X and Y
    if (int(XArg) >= int(YArg) ):
        print('Error: Parameter X for HMGT inference parameter must be less than parameter Y.')
        NoEx = 'f'
    else:
        executeFlag = 'true'
    # Z value
    if (ZArg != None and ZArg !=''):
        executeFlag = 'true'
    else:
        print('Error: Parameter Z for HMGT inference parameter must be an integer.')
        NoEx = 'f'
    #Mapping
    if (int(mapping) > 50 and int(mapping) <=100):
        executeFlag = 'true'
    else:
        print("Error: Mapping confidence threshold for transfers. Must be between 51 and 100. Defaults to 51.")
        NoEx = 'f'
    
    #Transfer  HMGT 
    if (int(TransferSupport_HMGT) > 0 and int(TransferSupport_HMGT) <=100):
        executeFlag = 'true'
    else:
        print("Error: Confidence threshold for inferring transfer events in HMGTs, must be greater than  0 and less than or equal 100")
        NoEx = 'f'
    #Transfer  HGT
    if (int(TransferSupport_HGT) > 0 and int(TransferSupport_HGT) <=100):
        executeFlag = 'true'
    else:
        print("Error: Confidence threshold for inferring transfer events in HGTs, must be greater than  0 and less than or equal 100")
        NoEx = 'f'
    

    if (NoEx == 'f'):
        sys.exit()
    else:
        Transfer(genefile, speciesTreefile, genomesFile, toSaveFolder)

class Transfer:
    def __init__(self, genePath,speciesTree, genomesFile, toSaveFolder):
        self.gene_file_path = genePath
        self.species_tree_path = speciesTree
        self.toSaveFolder = toSaveFolder
        self.genomeFiles = genomesFile
        self.starTheRun()
    
    def starTheRun(self):
        
        ## check that the species tree to run on rooted species trees without internal node labels
        self.checkSpeciesTree(self.species_tree_path)
        #Create main directory to save results
        mainDirectory = os.path.dirname(self.toSaveFolder+'/')#'tosave/') #self.toSaveFolder #os.path.dirname('RANGERresults/')
        if not os.path.exists(mainDirectory):
            os.makedirs(mainDirectory)
        
        #Combine species tree with genes trees 
        combine_folder = os.path.dirname(mainDirectory+'/RangerInput/')
        if not os.path.exists(combine_folder):
            os.makedirs(combine_folder)
        self.CombineSG(self.species_tree_path, self.gene_file_path, combine_folder)

        ###############################
        #fileTime =open("0TIME.txt", "a")
        #timeXX = time.time() - start_time
        #fileTime.write("Time needed to combine species tree with gene trees: "+str(timeXX)+"\n" )
        #################################

        # Ranger Transfer cost = 3
        #Run ranger function using transfer cost 3 and return a file to print species tree with internal nodes
        fileNameT3 = '/RangerOutput_TransferCost'+str(TransferCostArg1)+'/'
        fileNameT4 = '/RangerOutput_TransferCost'+str(TransferCostArg2)+'/'
        rangerDTL_folder_T3 = os.path.dirname(mainDirectory+fileNameT3)
        if not os.path.exists(rangerDTL_folder_T3):
            os.makedirs(rangerDTL_folder_T3)

        rangerDTL_folder_T4 = os.path.dirname(mainDirectory+fileNameT4)
        if not os.path.exists(rangerDTL_folder_T4):
            os.makedirs(rangerDTL_folder_T4)
        
        self.Ranger(rangerDTL_folder_T3, rangerDTL_folder_T4, combine_folder, int(TransferCostArg1), int(TransferCostArg2))  

        ###############################
        #timeXX = time.time() - start_time
        #fileTime.write("Time needed to finish first Range run: "+str(timeXX)+"\n" )
        #################################
 
        #Run Aggregate Recipient
        fileNameT3_R = '/ReconciliationResults_TransferCost'+str(TransferCostArg1)+'/'
        Aggregate_folder_T3 = os.path.dirname(mainDirectory+fileNameT3_R)
        if not os.path.exists(Aggregate_folder_T3):
            os.makedirs(Aggregate_folder_T3)
        self.AggregateRecipient(rangerDTL_folder_T3, Aggregate_folder_T3)

        ###############################
        #timeXX = time.time() - start_time
        #fileTime.write("Time needed to finish Range run: "+str(timeXX)+"\n" )
        #################################
  
        #Run Aggregate Recipient
        fileNameT4_R = '/ReconciliationResults_TransferCost'+str(TransferCostArg2)+'/'
        Aggregate_folder_T4 = os.path.dirname(mainDirectory+fileNameT4_R)
        if not os.path.exists(Aggregate_folder_T4):
            os.makedirs(Aggregate_folder_T4)
        self.AggregateRecipient(rangerDTL_folder_T4, Aggregate_folder_T4)
    
        ###############################
        #timeXX = time.time() - start_time
        #fileTime.write("Time needed to finish 2nd aggregate ranger: "+str(timeXX)+"\n" )
        #################################
        
        #Create HMGTs and HGTs lists
        #Create final Single HGT
        #fileNameT4_R = '/ReconciliationResults_TransferCost'+str(TransferCostArg2)+'/'
        #Aggregate_folder_T4 = os.path.dirname(mainDirectory+fileNameT4_R)
        #fileNameT3_R = '/ReconciliationResults_TransferCost'+str(TransferCostArg1)+'/'
        #Aggregate_folder_T3 = os.path.dirname(mainDirectory+fileNameT3_R)
        
        HGT_lists_folder = os.path.dirname(mainDirectory+'/Single_HGT_List/')
        if not os.path.exists(HGT_lists_folder):
            os.makedirs(HGT_lists_folder)
        self.getSingleHGTlist(mainDirectory, HGT_lists_folder, self.species_tree_path, self.genomeFiles, Aggregate_folder_T3, Aggregate_folder_T4)
        
        #######################################
        #timeXX = time.time() - start_time
        #fileTime.write("Time needed to finish preparing the single-HGT list: "+str(timeXX)+"\n" )
        #######################################
        #fileTime.close()
    #Read the files that have lists and return a dictionary of these files
    def getDict(self, FileHMGT):
        HMGT_dict = {}
        with open(FileHMGT, 'r') as f:
            for line in f:
                List1 = line.split(':')
                D_R = List1[0]
                transfersList = List1[1].split(',')

                for xx in transfersList:
                    if D_R in HMGT_dict:
                        HMGT_dict[D_R].append(xx.strip())
                    else:
                        HMGT_dict[D_R] = []
                        HMGT_dict[D_R].append(xx.strip()) 
        return HMGT_dict

    #Create HMGTs and HGTs
    def getSingleHGTlist(self, toSaveSingle, HGT_lists_folder, SpecTree, genomes, Aggregate_folder_T3, Aggregate_folder_T4):
        #New filtering method
        toSaveSingleHGT =HGT_lists_folder+'/Single_HGT.txt'
        DART_prep_NEW.main(['-i', str(allowed), '-o', Aggregate_folder_T3, '-a', Aggregate_folder_T4, '-d', str(immediateGenes), '-e', str(EachSide), '-s', SpecTree, '-n', genomes, '-k', RareGenesfile, '-t', str(TransferSupport_HMGT), '-u', str(TransferSupport_HGT),'-m',str(mapping),'-v',str(toSaveSingleHGT)])
        
        '''
        #HMGT method
        #toSaveHMGT310 =HGT_lists_folder+'/HMGT_T3_t10.txt'
        toSaveHMGT310 =HGT_lists_folder+'/HMGT_T'+str(TransferCostArg1)+'_t'+str(TransferSupport_HMGT)+'.txt'
        DART_prep.main(['-g', Aggregate_folder_T3, '-s', SpecTree, '-n', genomes, '-k', RareGenesfile, '-t', str(TransferSupport_HMGT), '-m',str(mapping),'-x',str(XArg),'-y',str(YArg),'-z',str(ZArg), '-a', toSaveHMGT310])

        #toSaveHMGT410 =HGT_lists_folder+'/HMGT_T4_t10.txt'
        toSaveHMGT410 =HGT_lists_folder+'/HMGT_T'+str(TransferCostArg2)+'_t'+str(TransferSupport_HMGT)+'.txt'
        DART_prep.main(['-g', Aggregate_folder_T4, '-s', SpecTree, '-n', genomes, '-k', RareGenesfile, '-t', str(TransferSupport_HMGT), '-m',str(mapping),'-x',str(XArg),'-y',str(YArg),'-z',str(ZArg), '-a', toSaveHMGT410])

        #toSaveHGT4100 =HGT_lists_folder+'/HGT_T4_t100.txt'
        toSaveHGT4100 =HGT_lists_folder+'/HGT_T'+str(TransferCostArg2)+'_t'+str(TransferSupport_HGT)+'.txt'
        DART_prep.main(['-g', Aggregate_folder_T4, '-s', SpecTree, '-n', genomes, '-k', RareGenesfile, '-t', str(TransferSupport_HGT), '-m', str(mapping),'-r', '1', '-x',str(XArg),'-y',str(YArg),'-z',str(ZArg), '-a', toSaveHGT4100])
        
        HMGT_T3_List10_dict = self.getDict(toSaveHMGT310)
        HMGT_T4_List10_dict = self.getDict(toSaveHMGT410)
        HGT_T4_List100_dict = self.getDict(toSaveHGT4100)
        #Create final Single HGT
        SingleHGT_List = []
        ProbFile=open(toSaveSingle+"/Single_HGT.txt", "a")
                                        
        for keyGTx in HGT_T4_List100_dict:
            List11 = HGT_T4_List100_dict[keyGTx]
            List22 = []
            List33 = []
            if keyGTx in HMGT_T3_List10_dict:
                List22 = HMGT_T3_List10_dict[keyGTx]
            if keyGTx in HMGT_T4_List10_dict:
                List33 = HMGT_T4_List10_dict[keyGTx]
            lst1x = [value for value in List11 if value not in List22] 
            lst2x = [value for value in lst1x if value not in List33] 
            txtKeyW = ''
            if len(lst2x) > 0:
                for xv in lst2x:
                    txtKeyW = txtKeyW + xv + ','
                    SingleHGT_List.append(xv)
                txtKeyW = txtKeyW[:-1]
                #print(keyGTx+':'+txtKeyW)
            
                ProbFile.write(keyGTx+':'+txtKeyW)
                ProbFile.write('\n')
        ProbFile.close()
        '''
                      
    #-----------
    def checkSpeciesTree(self, STfile):
        internalNodes = []
        leafNodes = []
        my_file = Path(STfile)
        if my_file.is_file():
            with open(STfile, "r") as f:
                try:
                    for line in f:
                        if not line.strip():#if there are an empty lines
                            continue
                        else:
                            species_tree = line #Read the species tree in a single line 
                            st = Tree(species_tree, format=1)
                            #preorder: 1)Visit the root, 2) Traverse the left subtree , 
                            # 3) Traverse the right subtree. postorder: 1) Traverse the 
                            # left subtree , 2) Traverse the right subtree, 3) Visit the 
                            # root levelorder (default): every node on a level before is 
                            # visited going to a lower level
                            for node in st.traverse("postorder"): 
                                if node.is_leaf():
                                    leafNodes.append(node.name)
                                else:
                                    internalNodes.append(node.name)
                            break
                    
                except IOError:
                    print("Can't open the files", STfile)
                except Exception as ex:
                    print(ex)
        #if no inernal nodes then empty the array that filled with spaces  ['','','']
        if (internalNodes[0] == ''):
            internalNodes[:] = []
        else:
            print('Error: Species tree provided should be rooted species trees without internal node labels')
            sys.exit()
    #----------- Combine the species tree and gene trees in one file to prepare for RANGER-DTL
    def CombineSG(self, STfile, gFile, toSave):
        #get tye species tree 
        speciesTree = ''
        with open(STfile, 'r') as s:
            for line in s:
                if not line.strip(): #skip empty lines
                    continue
                else:
                    speciesTree = line
        if os.path.exists(gFile): #check if gene directory found
            onlyfiles = [f for f in listdir(gFile) if isfile(join(gFile, f))]
            if not onlyfiles:
                print("Gene folder is empty")
            else:
                for file in onlyfiles:
                    with open(gFile+'/'+file, 'r') as f:
                        for line in f:
                            if not line.strip(): #skip empty lines
                                continue
                            else:
                                dirname = os.path.dirname(toSave+'/'+file)
                                if not os.path.exists(dirname):
                                    os.makedirs(dirname)
                                with open(dirname+'/'+file, 'w')as gsfile:
                                    gsfile.write(speciesTree)
                                    gsfile.write('\n')
                                    gsfile.write(line)
                                    gsfile.close()                      
        else:
            print("No such directory", gFile, "found")
    
    #Run RANGER-DTL
    def Ranger(self, rangerDTL_folder3, rangerDTL_folder4, combine_folder, transfer_cost3, transfer_cost4):
        if platform.system() == 'Linux':
            if path.exists("Ranger-DTL.linux"):
                command = "chmod 755 ./Ranger-DTL.linux"
                os.system(command)
                onlyfiles = [f for f in listdir(combine_folder) if isfile(join(combine_folder, f))]
                for file in onlyfiles:
                    directory3 = os.path.dirname(rangerDTL_folder3+'/'+file+'/')
                    if not os.path.exists(directory3):
                        os.makedirs(directory3)
                    directory4 = os.path.dirname(rangerDTL_folder4+'/'+file+'/')
                    if not os.path.exists(directory4):
                        os.makedirs(directory4)
                    
                    for i in range(1,101):
                        command = "./Ranger-DTL.linux -i "+combine_folder+"/"+file+" -o "+directory3+"/"+file+"_"+str(i) +" --seed "+str(i)+" -T "+ str(transfer_cost3)
                        os.system(command)  
                        command = "./Ranger-DTL.linux -i "+combine_folder+"/"+file+" -o "+directory4+"/"+file+"_"+str(i) +" --seed "+str(i)+" -T "+ str(transfer_cost4)
                        os.system(command)  
            else:
                print('File Ranger-DTL.linux is not exist.')
                sys.exit()
        else: # platform.system() == 'Darwin':
            if path.exists("Ranger-DTL.mac"):
                command = "chmod 755 ./Ranger-DTL.mac"
                os.system(command)
                onlyfiles = [f for f in listdir(combine_folder) if isfile(join(combine_folder, f))]
                for file in onlyfiles:
                    directory3 = os.path.dirname(rangerDTL_folder3+'/'+file+'/')
                    if not os.path.exists(directory3):
                        os.makedirs(directory3)
                    directory4 = os.path.dirname(rangerDTL_folder4+'/'+file+'/')
                    if not os.path.exists(directory4):
                        os.makedirs(directory4)
                    
                    for i in range(1,101):
                        command = "./Ranger-DTL.mac -i "+combine_folder+"/"+file+" -o "+directory3+"/"+file+"_"+str(i) +" --seed "+str(i)+" -T "+ str(transfer_cost3)
                        os.system(command) 
                        command = "./Ranger-DTL.mac -i "+combine_folder+"/"+file+" -o "+directory4+"/"+file+"_"+str(i) +" --seed "+str(i)+" -T "+ str(transfer_cost4)
                        os.system(command) 
            else:
                print('File Ranger-DTL.mac is not exist.')
                sys.exit() 

    #Run aggregate Recipient
    def AggregateRecipient(self, rangerDTL_folder, Aggregate_folder):
        if platform.system() == 'Linux':
            if path.exists("AggregateRecipient.linux"):
                command = "chmod 755 ./AggregateRecipient.linux"
                os.system(command)
                dirs = [d for d in os.listdir(rangerDTL_folder) if os.path.isdir(os.path.join(rangerDTL_folder, d))]
                for d in dirs:
                    newPath =  rangerDTL_folder+'/'+d+'/'+d+'_'
                    saveF = Aggregate_folder +'/'+d
                    command = "./AggregateRecipient.linux "+newPath+" > "+saveF
                    os.system(command)  
            else:
                print('File AggregateRecipient.linux is not exist.')
                sys.exit()
        else: # platform.system() == 'Darwin':
            if path.exists("AggregateRecipient.mac"):
                command = "chmod 755 ./AggregateRecipient.mac"
                os.system(command)
                dirs = [d for d in os.listdir(rangerDTL_folder) if os.path.isdir(os.path.join(rangerDTL_folder, d))]
                for d in dirs:
                    newPath =  rangerDTL_folder+'/'+d+'/'+d+'_'
                    saveF = Aggregate_folder +'/'+d
                    command = "./AggregateRecipient.mac "+newPath+" > "+saveF
                    os.system(command)  
            else:
                print('File AggregateRecipient.mac is not exist.')
                sys.exit()
if __name__ == "__main__":
   main(sys.argv[1:])