import glob 
import re
import numpy as np 
import sys, getopt
import os
import math
import random
from pathlib import Path
from os import listdir
from os.path import isfile, join 
import os.path
from ete3 import Tree

allowed = 1
AggregateFile3 = ''
AggregateFile4 = ''
RareGenesfile = ''
NumberofImediat = 2
EachSide = 4
ToSaveFileX = ''
TransferSupport_HMGT = 10
TransferSupport_HGT = 100
mapping = 51
def main(argv):
    global allowed
    global AggregateFile3
    global AggregateFile4
    global NumberofImediat
    global EachSide
    global SpecTree
    global genomes
    global RareGenesfile
    global TransferSupport_HMGT
    global TransferSupport_HGT
    global mapping
    global ToSaveFileX

    try:
        opts, args = getopt.getopt(argv,"hi:o:a:d:e:s:n:k:t:u:m:v:",["ifile=","ofile=","afile=","numImm=","EachSide=","specTree=","genome=","RareGenesfile=","transHMGT=","transHGT=","mapping","tosavefile="])
    except getopt.GetoptError:
        print('test.py -i <inputfile> -o <outputfile>')
        sys.exit(2)
    for opt, arg in opts:
        if opt == '-h':
            print('test.py -i <inputfile> -o <outputfile>')
            sys.exit()
        elif opt in ("-i", "--ifile"):
            allowed = arg
        elif opt in ("-o", "--ofile"):
            AggregateFile3_1 = arg
            AggregateFile3 = AggregateFile3_1+'/'
        elif opt in ("-a", "--afile"):
            AggregateFile4_1 = arg   
            AggregateFile4 = AggregateFile4_1+'/'
        elif opt in ("-d", "--numImm"):
            NumberofImediat = arg
        elif opt in ("-e", "--EachSide"):
            EachSide = arg
        elif opt in ("-s", "--specTree"):
            SpecTree = arg
        elif opt in ("-n", "--genome"):
            genomess = arg
            genomes = genomess+'/'
        elif opt in ("-k", "--RareGenesfile"):
            RareGenesfile = arg
        elif opt in ("-t", "--transHMGT"):
            TransferSupport_HMGT = arg
        elif opt in ("-u", "--transHGT"):
            TransferSupport_HGT = arg
        elif opt in ("-m", "--mapping"):
            mapping = arg
        #tosavefile
        elif opt in ("-v", "--tosavefile"):
            ToSaveFileX = arg
    Transfer(allowed, AggregateFile3, AggregateFile4)

class Transfer:
    def __init__(self, allowed, AggregateFile3, AggregateFile4):
        self.allowed = allowed
        self.AggregateFile3 = AggregateFile3
        self.AggregateFile4 = AggregateFile4
        self.AllGenomes_dict = {} # dictionary that has all species and all thier genefamily_geneName
        self.AllGenomes_lists_dict = {}
        self.AllGenomes_contig_dict = {}
        self.startTheRun(self.AggregateFile3, self.AggregateFile4)

    def countGeneFamily(self, geneFam, speciesListOFlists):
        counter = 0
        for lists in speciesListOFlists:
            for items in lists:
                if '>' in items:
                    geneFamily = items.split('>')[0].strip()
                    if geneFamily == geneFam:
                        counter = counter + 1
        return counter
    def returnGeneName(self, geneFam, speciesListOFlists):
        geneNameList = []
        for lists in speciesListOFlists:
            for items in lists:
                if '>' in items:
                    geneFamily = items.split('>')[0].strip()
                    geneName = items.split('>')[1].strip()
                    if geneFamily == geneFam:
                        geneNameList.append(geneName)
        return geneNameList

    def read_file_gene(self, file_name, transferArg, mappingArg, nodes):
        mDonor = ''
        mRecipient = ''
        dGENEname = ' '
        rGENEname = ' '
        leafNode_list = [] #list to add the leaf node species
        leafNode_All_list = []
        flagInM = 'f' #flag to fill the leafNode_list list when there are lines after each other,
        # when it get to the line that contain a transfer then it must use the list as long as there 
        # are more lines of transfers, other wise empty the list and fill it again with the : leaf nodes
        All_List=[]
        Across_List = []
        Within_List = [] 
        Problem_List = []
        FileName = file_name
        leafNode_All_list = self.getLeafNodesList(FileName)
        
        with open(FileName, 'r') as f:
            #try:
            for line in f:
                dGENEname = 'f'
                rGENEname = 'f'
                if ': Leaf Node' in line:
                    leafNode_list.append(line.split(':')[0].strip())
                elif re.match("(.*)Transfers =", line):
                    flagInM = 't' # set flag to true to indicate of start using the list of leaf nodes
                    tr = line.split('Transfers = ')[-1].split('],')[0].strip()#read the transfer number from the file
                    tr = int(tr.strip())

                    
                    if (tr != 0 and int(transferArg) != 0 and tr >= int(transferArg)):#compare the transfer 
                        md = line.split('Most Frequent mapping -->')[-1].split('times],')[0].strip()
                        mappingDr = md.split(',')
                        mappingDonor = int(mappingDr[1])

                        mr = line.split('[Most Frequent recipient -->')[-1].split('times].')[0].strip()
                        mappingRr = mr.split(',')
                        mappingRecipient = int(mappingRr[1])  
                        geneFamily1 = os.path.basename(f.name)
                        if '_' in geneFamily1:
                            geneFamily = geneFamily1.split("_",1)[0] #get the gene name before the first underscore ex: 10016_cHG.RAxML.rooted
                        else:
                            geneFamily = geneFamily1.split(".",1)[0] #get the gene name before the first dot ex: 100.besTree.rooted
                        #Return the Underscore to the species names
                        #continue if the node is an internal node
                        if (mappingDr[0].strip() in nodes and mappingRr[0].strip() in nodes):
                            mDonor = mappingDr[0].strip()
                            mRecipient = mappingRr[0].strip()
                            ########get gene name ##########################
                            #######################################################
                            SSP_R = ''
                            SSP_D = ''
                            DcountGeneFam = 0
                            RcountGeneFam = 0
                            
                            ##### Check if unique #######################################
                            #DONOR - Check if the gene family for that species is unique 
                            
                            if ((mDonor in nodes) and (mRecipient in nodes)):
                                
                                DcountGeneFam = self.countGeneFamily(geneFamily, self.AllGenomes_lists_dict[mDonor]) #fff = open(genomes+mDonor+'.synteny', 'r').read() #genomefile+'/'+items.donor+extArg, 'r').read()
                                #DcountGeneFam = fff.count(':'+geneFamily+'\t')
                                # DONOR - if unique (the gene family only appears once in the genome file )   
                                if (DcountGeneFam == 1) : # if true then get the gene name
                                    #Check if unique ( the species appear just once in all the leaf node list)
                                    for l_sp in leafNode_All_list:
                                        
                                        sps = l_sp.strip().split('_')[0] # get species name
                                        if (sps == mappingDr[0].strip()):#mDonor.replace('_','')):
                                            #countTimesD = countTimesD + 1
                                            SSP_D = l_sp
                                            break
                                    #get the gene name
                                    if (SSP_D != ''):
                                        li_len = len(SSP_D.strip().split('_')) #get the length of the elements list ex: AdiversaCECT4254T_26797_2810, length = 3
                                        dGENEname = SSP_D.strip().split('_')[li_len-1]

                                #RECIPIENT - Check if the gene family for that species is unique 
                                
                                #fffR = open(genomes+mRecipient+'.synteny', 'r').read() #genomefile+'/'+items.donor+extArg, 'r').read()
                                #RcountGeneFam = fffR.count(':'+geneFamily+'\t')
                                RcountGeneFam = self.countGeneFamily(geneFamily, self.AllGenomes_lists_dict[mRecipient])
                                # DONOR - if unique (the gene family only appears once in the genome file )   
                                if (RcountGeneFam == 1) : # if true then get the gene name
                                    #Check if unique ( the species appear just once in all the leaf node list)
                                    for l_sp in leafNode_All_list:
                                        sps = l_sp.strip().split('_')[0] # get species name
                                        if (sps == mappingRr[0].strip()):#mDonor.replace('_','')):
                                            #countTimesD = countTimesD + 1
                                            SSP_R = l_sp
                                            break
                                    #get the gene name
                                    if (SSP_R != ''):
                                        li_len = len(SSP_R.strip().split('_')) #get the length of the elements list ex: AdiversaCECT4254T_26797_2810, length = 3
                                        rGENEname = SSP_R.strip().split('_')[li_len-1]
                                
                                    ##############################################################
                                #LCA[AveroniiLMG13067_18297_2183, AveroniiCECT4486_26530_1089]
                                
                                #Check donor if not unique then it should be in LCA and in leaf node above
                                LCA = re.search('LCA(.*)]:', line).group(1).strip()[1:] #remove [ from the begining of the line
                                d_r = LCA.split(',') # list contains the donor and the recipient [AveroniiAER397_26978_9, AveroniiCECT7059_51_2520]
                                #check the donor if not unique
                                if (dGENEname == 'f' and len(leafNode_list)> 1):
                                    dGENEname = self.IsGoodTrans(d_r, mappingDr[0], leafNode_list)
                                #check the Recipient 
                                if (rGENEname == 'f' and len(leafNode_list)> 1):
                                    rGENEname = self.IsGoodTrans(d_r, mappingRr[0], leafNode_list)
                                
                                leafNode_list[:] = []  # empty the list
                                #######end get the gene name ##################
                                #Dont add if there are no exact gene name found
                                extArg = '.synteny'
                                if (mappingDonor >= int(mappingArg) and mappingRecipient >= int(mappingArg)):  #Transfer times > 50
                                    if (rGENEname != 'f' and dGENEname != 'f'):
                                        if mDonor[:4] != mRecipient[:4]:
                                            Across_List.append(mDonor+'>'+mRecipient+'>'+geneFamily+'>'+dGENEname+'>'+rGENEname)
                                            
                                        elif mDonor[:4] == mRecipient[:4]:
                                            Within_List.append(mDonor+'>'+mRecipient+'>'+geneFamily+'>'+dGENEname+'>'+rGENEname)
                                        All_List.append(mDonor+'>'+mRecipient+'>'+geneFamily+'>'+dGENEname+'>'+rGENEname)
                                               
                                    else:
                                        if dGENEname == 'f' and rGENEname != 'f':
                                            #speciesFile = genomes+mDonor+extArg
                                            #getGeneNamesD = self.getAllGeneNames(speciesFile, geneFamily)
                                            getGeneNamesD = self.returnGeneName(geneFamily, self.AllGenomes_lists_dict[mDonor])
                                            if len(getGeneNamesD) >0:
                                                for gNam in getGeneNamesD:
                                                    Problem_List.append(mDonor+'>'+mRecipient+'>'+geneFamily+'>'+gNam+'>'+rGENEname)
                                
                                            if rGENEname == 'f' and dGENEname != 'f':
                                                #speciesFile = genomes+mRecipient+extArg
                                                #getGeneNamesR = self.getAllGeneNames(speciesFile, geneFamily)
                                                getGeneNamesR = self.returnGeneName(geneFamily, self.AllGenomes_lists_dict[mRecipient])
                                                if len(getGeneNamesR) >0:
                                                    for gNamX in getGeneNamesR:
                                                        Problem_List.append(mDonor+'>'+mRecipient+'>'+geneFamily+'>'+dGENEname+'>'+gNamX)
                                                        
                                            if rGENEname == 'f' and dGENEname == 'f':
                                                #speciesFile = genomes+mDonor+extArg
                                                #getGeneNamesD = self.getAllGeneNames(speciesFile, geneFamily)
                                                getGeneNamesD = self.returnGeneName(geneFamily, self.AllGenomes_lists_dict[mDonor])
                                                
                                                #speciesFile = genomes+mRecipient+extArg
                                                #getGeneNamesR = self.getAllGeneNames(speciesFile, geneFamily)
                                                getGeneNamesR = self.returnGeneName(geneFamily, self.AllGenomes_lists_dict[mRecipient])
                                                if len(getGeneNamesD) >0 and len(getGeneNamesR) > 0 :
                                                    for gNamX in getGeneNamesD:
                                                        for gNamXr in getGeneNamesR:
                                                            Problem_List.append(mDonor+'>'+mRecipient+'>'+geneFamily+'>'+gNamX+'>'+gNamXr)
                                                            
                                        
        return All_List, Across_List, Within_List, Problem_List #Across_List,  Within_List, Problem_List
    
    def getAllGeneNames(self, file_name, geneFam):
        cont = '_contig_'
        flag = 0
        get_file_name = os.path.basename(file_name)
        get_path = os.path.dirname(file_name)
        sp_name = get_file_name[0:get_file_name.find('.')] #remove .txt.sy
        genomeList = []
      
        if (file_name):
            with open(file_name, 'r') as f:
                for line in f:
                    if not line.strip(): #skip empty lines
                        continue
                    else:
                        if cont in line:#check if contig in file, otherwise get the string between first and second :
                            contig = line.split('_contig_')[-1].split(':')[0].strip()
                            conPrefix = '_contig_'+contig
                        else:
                            l = line.split(':')
                            contig = l[1]
                            conPrefix = contig
                        if sp_name in line:
                            species = line.split(sp_name)  #each gene info 
                        
                        geneCounter = 0
                        flag = 0
                        for s_species in species:
                            if flag == 0: #to solve the problem of overcounting as the first one is empty
                                flag = 1
                            else:
                                #print("Species Info: ", s_species)
                                geneFamily = s_species.split(':')[-1].strip()
                                geneName = s_species.split(':')[1].strip()
                                if geneFamily == geneFam:
                                    genomeList.append(geneName)
                                    
        else:
            print("File not exist") 
        return  genomeList

    def IsGoodTrans(self, d_r, speci, leafNode_list):                      
        one_list = []
        two_list = []
        GENEname = 'f'
        one_list = d_r[0].strip().split('_') # AveroniiAER397_26978_9 -> one_list = [AveroniiAER397, 26978, 9] where 9 is the gene name
        two_list = d_r[1].strip().split('_')
        #check if it is in LCA and matches the leaf node above
        if (one_list[0] == speci.strip()): #mDonor.replace('_','')): # if species1 = donor 
            #Check if it is in leaf node list 
            for list_sp in leafNode_list:
                if list_sp == d_r[0].strip():
                    GENEname = one_list[len(one_list) -1] # get gene name for the donor            
        elif (two_list[0] == speci.strip()): #mDonor.replace('_','')): # if species2 = donor 
            for list_sp in leafNode_list:
                if list_sp == d_r[1].strip():
                    GENEname = two_list[len(two_list) -1] # get gene name for the donor
        return GENEname

    def initiate_species_tree(self):
        nodes = []
        AllGenomes_lists_dict = {}

        with open(SpecTree, "r") as f: #  'RAxML_SpeciesTree.tre', "r") as f:
            for line in f:
                species_tree = line #Read the species tree in a single line 
                tree = Tree(species_tree, format=1)
                for node in tree.traverse("postorder"): 
                    nodes.append(node.name)
            
            nodes = list(filter(None, nodes))
        f.close()


        #####################################################################
        #### Fill dictionary with all genomes 
        genefam_geneNameList = []
        speciesList = []
        path = genomes
        if os.path.exists(path): #check if genome directory found
            onlyfiles = [f for f in listdir(path) if isfile(join(path, f))]
            if not onlyfiles:
                print("Genomes folder is empty")
            else:
                for file in onlyfiles:
                    get_file_name = os.path.basename(file)
                    sp_name = get_file_name[0:get_file_name.find('.')] #remove .txt.sy
                    #print(file)
                    
                    genefam_geneNameList , genefam_geneNameList_contig = self.getGenomeList(path+file) # get list of geneFamily_geneNames
                    #append 0's at the first and the end of the list
                    key = sp_name
                    if key in self.AllGenomes_dict:
                        self.AllGenomes_dict[key].extend(speciesList)
                    else:
                        self.AllGenomes_dict[key] = []
                        self.AllGenomes_dict[key].extend(speciesList) 
                    ### contig list
                    if key in self.AllGenomes_contig_dict:
                        self.AllGenomes_contig_dict[key].extend(genefam_geneNameList_contig)
                    else:
                        self.AllGenomes_contig_dict[key] = []
                        self.AllGenomes_contig_dict[key].extend(genefam_geneNameList_contig) 
                    genefam_geneNameList[:] = [] #empty the list
                    genefam_geneNameList_contig[:]=[]
                    speciesList[:] = []
                    ####################################################################  
                    ##################################
                    genefam_geneNameList_ofLists = self.getGenomeList_ListOfLists(path+file) # get list of lists geneFamily_geneNames
                    #append 0's at the first and the end of the list
                    
                    key = sp_name
                    if key in self.AllGenomes_lists_dict:
                        self.AllGenomes_lists_dict[key].extend(genefam_geneNameList_ofLists)
                    else:
                        self.AllGenomes_lists_dict[key] = []
                        self.AllGenomes_lists_dict[key].extend(genefam_geneNameList_ofLists) 

            '''
            #####################################################################
            #### Fill dictionary with all genomes 
            genefam_geneNameList_ofLists = []
            
            for species in nodes:
                genefam_geneNameList_ofLists = self.getGenomeList_ListOfLists(genomes+species+'.synteny') # get list of lists geneFamily_geneNames   
                key = species
                if key in AllGenomes_lists_dict:
                    AllGenomes_lists_dict[key].extend(genefam_geneNameList_ofLists)
                else:
                    AllGenomes_lists_dict[key] = []
                    AllGenomes_lists_dict[key].extend(genefam_geneNameList_ofLists) 
            '''
        return nodes,  self.AllGenomes_lists_dict

    def getGenomeList(self, file_name):
        cont = '_contig_'
        flag = 0
        geneCounter = 0
        get_file_name = os.path.basename(file_name)
        get_path = os.path.dirname(file_name)
        sp_name = get_file_name[0:get_file_name.find('.')] #remove .txt.sy
        genomeList = []
        genomeList_contig = []
      
        if (file_name):
            with open(file_name, 'r') as f:
                for line in f:
                    if not line.strip(): #skip empty lines
                        continue
                    else:
                        if cont in line:#check if contig in file, otherwise get the string between first and second :
                            contig = line.split('_contig_')[-1].split(':')[0].strip()
                            conPrefix = '_contig_'+contig
                        else:
                            l = line.split(':')
                            contig = l[1]
                            conPrefix = contig
                        if sp_name in line:
                            species = line.split(sp_name)  #each gene info 
                        
                        geneCounter = 0
                        flag = 0
                        for s_species in species:
                            if flag == 0: #to solve the problem of overcounting as the first one is empty
                                flag = 1
                            else:
                                #print("Species Info: ", s_species)
                                geneFamily = s_species.split(':')[-1].strip()
                                geneName = s_species.split(':')[1].strip()
                                geneCounter = geneCounter + 1
                                key = geneFamily+'>'+geneName
                                key2 = geneFamily+'>'+geneName +'*'+contig+'>'+str(geneCounter)
                                
                                genomeList.append(key)  
                                genomeList_contig.append(key2)     
        else:
            print("File not exist") 
        return  genomeList , genomeList_contig

    def getGenomeList_ListOfLists(self, file_name):
        cont = '_contig_'
        flag = 0
        get_file_name = os.path.basename(file_name)
        get_path = os.path.dirname(file_name)
        sp_name = get_file_name[0:get_file_name.find('.')] #remove .txt.sy
        genomeList = []
        contig = ''
        listOfLists = []
        tempContig = ''
        TemplistOfLists = []
        if (file_name):
            with open(file_name, 'r') as f:
                for line in f:
                    if not line.strip(): #skip empty lines
                        continue
                    else:
                        if cont in line:#check if contig in file, otherwise get the string between first and second :
                            contig = line.split('_contig_')[-1].split(':')[0].strip()
                            conPrefix = '_contig_'+contig
                        else:
                            l = line.split(':')
                            contig = l[1]
                            conPrefix = contig
                        if sp_name in line:
                            species = line.split(sp_name)  #each gene info 
                        tempContig = contig
                        geneCounter = 0
                        flag = 0

                        TemplistOfLists = []
                        genomeList = [] #empty the list
                        for s_species in species:
                            
                            if flag == 0: #to solve the problem of overcounting as the first one is empty
                                flag = 1
                            else:
                                #print("Species Info: ", s_species)
                                geneFamily = s_species.split(':')[-1].strip()
                                geneName = s_species.split(':')[1].strip()
                                
                                key = geneFamily+'>'+geneName
                                
                                genomeList.append(key)
                                
                        
                        for x in range (0,4):
                            TemplistOfLists.append('0')
                        for v in genomeList:
                            TemplistOfLists.append(v)
                        for x in range (0,4):
                            TemplistOfLists.append('0')
                        #genomeList[:] = [] #empty the list
                        listOfLists.append(TemplistOfLists)
                        #TemplistOfLists[:] = []
        return  listOfLists


    def getLeafNodesList(self, FileName):
        leafNode_All_list = []
        with open(FileName, 'r') as f1:
            for line1 in f1:
                if ': Leaf Node' in line1:
                    leafNode_All_list.append(line1.split(':')[0].strip())
        f1.close()

        return leafNode_All_list
        
    def printFile(self, fileNameX, Plist):
        AFile=open(fileNameX, "a+")
        for ele in Plist:
            AFile.write(ele + '\n')
        AFile.close()

    def getAroundList(self, EachSide, ListDR, idx):
        DRlist = []
        startIdx = idx - int(EachSide)
        lastIdx = idx + int(EachSide)
        if startIdx < 0:
            startIdx = 0
        if lastIdx >= len(ListDR):
            lastIdx = len(ListDR)-1
        #Case of single transfer, then look for 4 genes before and 4 genes after
        
        for x in range (startIdx, idx):#idx+1):
            DRlist.append(ListDR[x]) #add the items from the list (should be the gene families around)
        #Case of HMGTs, last gene family, and we need to compare gene families after this one
        #print(len(ListDR), startIdx,lastIdx )
        for x in range (idx+1, lastIdx+1): #(idx, lastIdx+1):
            DRlist.append(ListDR[x]) #add the items from the list (should be the gene families around)
        return DRlist

    def checkTransfer(self, fileName):
        #Donor>recipient>geneFamily>geneNameD>GeneNameR #transfer genes from t=10 and T=3 and 4
        geneList = []
        
        with open(fileName, 'r') as ff:
            for line1 in ff:
                donor = line1.split('>')[0].strip()
                recip = line1.split('>')[1].strip()
                gnF = line1.split('>')[2].strip()
                DgName = line1.split('>')[3].strip()
                RgName = line1.split('>')[4].strip()
                geneList.append(recip+'>'+gnF+'>'+RgName)
        return geneList      

    def checkTransfer_donor(self, fileName):
        #Donor>recipient>geneFamily>geneNameD>GeneNameR #transfer genes from t=10 and T=3 and 4
        geneList = []
        geneListanyDonor = []
        for line1 in fileName:
            donor = line1.split('>')[0].strip()
            recip = line1.split('>')[1].strip()
            gnF = line1.split('>')[2].strip()
            DgName = line1.split('>')[3].strip()
            RgName = line1.split('>')[4].strip()
            geneList.append(donor+'>'+recip+'>'+gnF+'>'+RgName)
            geneListanyDonor.append(recip+'>'+gnF+'>'+RgName)
        return geneList , geneListanyDonor     

    def fill_Recon(self, fileName):
        Recon_List = []
        with open(fileName, 'r') as recon: #chg_ALL.nog.emapper.annotations
            for line11 in recon:
                if not line11.strip(): #skip empty lines
                    continue
                else:
                    geneF = line11.split(':')[0].strip() #get gene family
                    TransDD = line11.split(':')[1].strip()
                    ListTransD = TransDD.split(',')
                    for transW in ListTransD:
                        Recon_List.append(transW+'>'+geneF)
        return  Recon_List
        #Donor>recip>geneFam
        
    def checkTransfer_rare(self, fileName):
        geneList = []
        full_geneList = []
        geneFamList = []
        geneFamDict = {}
        geneListAnyDonor =[]
        my_file = Path(fileName)
        if my_file.is_file():
            with open(fileName, 'r') as ff:
                for line1 in ff:
                    gnF = line1.split('>')[0].strip()
                    RgName = line1.split('>')[1].strip()
                    recip = line1.split('>')[2].strip()
                    geneList.append(recip+'>'+gnF+'>'+RgName)
                    key = gnF
                    if key in geneFamDict:
                        geneFamDict[key].append(recip+'>'+RgName)
                    else:
                        geneFamDict[key] = []
                        geneFamDict[key].append(recip+'>'+RgName)

            #### 
            for keyx in geneFamDict:
                gnFamily = keyx
                if len(geneFamDict[keyx]) == 1:
                    Rare1 = geneFamDict[keyx][0]
                    rare1_recip = Rare1.split('>')[0].strip()
                    rare1_Rgname = Rare1.split('>')[1].strip()
                    full_geneList.append('0'+'>'+rare1_recip+'>'+gnFamily+'>'+rare1_Rgname)
                    geneListAnyDonor.append(rare1_recip+'>'+gnFamily+'>'+rare1_Rgname)
                elif len(geneFamDict[keyx]) == 2:
                    Rare1 = geneFamDict[keyx][0]  #recip+'>'+RgName
                    rare1_recip = Rare1.split('>')[0].strip()
                    rare1_Rgname = Rare1.split('>')[1].strip()
                    Rare2 = geneFamDict[keyx][1]   #recip+'>'+RgName
                    rare2_recip = Rare2.split('>')[0].strip()
                    rare2_Rgname = Rare2.split('>')[1].strip()
                    full_geneList.append(rare1_recip+'>'+rare2_recip+'>'+gnFamily+'>'+rare2_Rgname)
                    full_geneList.append(rare2_recip+'>'+rare1_recip+'>'+gnFamily+'>'+rare1_Rgname)

                    geneListAnyDonor.append(rare2_recip+'>'+gnFamily+'>'+rare2_Rgname)
                    geneListAnyDonor.append(rare1_recip+'>'+gnFamily+'>'+rare1_Rgname)
                elif len(geneFamDict[keyx]) == 3:
                    Rare1 = geneFamDict[keyx][0]  #recip+'>'+RgName
                    rare1_recip = Rare1.split('>')[0].strip()
                    rare1_Rgname = Rare1.split('>')[1].strip()
                    Rare2 = geneFamDict[keyx][1]   #recip+'>'+RgName
                    rare2_recip = Rare2.split('>')[0].strip()
                    rare2_Rgname = Rare2.split('>')[1].strip()
                    Rare3 = geneFamDict[keyx][2]   #recip+'>'+RgName
                    rare3_recip = Rare3.split('>')[0].strip()
                    rare3_Rgname = Rare3.split('>')[1].strip()
                    
                    full_geneList.append(rare1_recip+'>'+rare2_recip+'>'+gnFamily+'>'+rare2_Rgname)
                    full_geneList.append(rare1_recip+'>'+rare3_recip+'>'+gnFamily+'>'+rare3_Rgname)

                    full_geneList.append(rare2_recip+'>'+rare1_recip+'>'+gnFamily+'>'+rare1_Rgname)
                    full_geneList.append(rare2_recip+'>'+rare3_recip+'>'+gnFamily+'>'+rare3_Rgname)

                    full_geneList.append(rare3_recip+'>'+rare1_recip+'>'+gnFamily+'>'+rare1_Rgname)
                    full_geneList.append(rare3_recip+'>'+rare2_recip+'>'+gnFamily+'>'+rare2_Rgname)
            
                    geneListAnyDonor.append(rare2_recip+'>'+gnFamily+'>'+rare2_Rgname)
                    geneListAnyDonor.append(rare3_recip+'>'+gnFamily+'>'+rare3_Rgname)
                    geneListAnyDonor.append(rare1_recip+'>'+gnFamily+'>'+rare1_Rgname)
                    
        return full_geneList, geneListAnyDonor 

    def checkTransfer_problem(self, fileName):
        #Donor>recipient>geneFamily>geneNameD>GeneNameR #transfer genes from t=10 and T=3 and 4
        geneList = []
        geneListAnyDonor = []
        for line1 in fileName:
            donor = line1.split('>')[0].strip()
            recip = line1.split('>')[1].strip()
            gnF = line1.split('>')[2].strip()
            geneList.append(donor+'>'+recip+'>'+gnF)
            geneListAnyDonor.append(recip+'>'+gnF)
        return geneList, geneListAnyDonor   

    def startTheRun(self, AggregateFile3, AggregateFile4):
        nodes, AllGenomes_lists_dict = self.initiate_species_tree() # return nodes,  AllGenomes_lists_dict

        
        ### Build lists of transfers 
        All_ListX, ProblemX = [],[]
        across_withint_10_T34, prob = [],[]
        across_withint_100_T4_full, across_100_T4_full, withint_100_T4_full = [],[],[]
        #get the list of transfer using transfer support t=10 and cost T =3
        STfile3 = AggregateFile3 #'AggregateRangerT3_More/' #'AggregateRangerT4_More/'
        STfile4 = AggregateFile4 #'AggregateRangerT4_More/' #'AggregateRangerT4_More/'
        RareFile = RareGenesfile #'Transfers_Lists/Rare_full_3_2_1.txt'
        onlyfiles = [f for f in listdir(STfile3) if isfile(join(STfile3, f))]  
        for file in onlyfiles:
            # transfer 10, mapping 51
            All_ListX, acr_L, with_l, ProblemX = self.read_file_gene(STfile3+file, TransferSupport_HMGT, mapping, nodes) # return A_list, W_list, problem 
            across_withint_10_T34.extend(All_ListX)
            prob.extend(ProblemX)

        #get the list of transfer using transfer support t=10 and cost T =3
        All_ListX4, ProblemX4 = [],[]
        onlyfiles = [f for f in listdir(STfile4) if isfile(join(STfile4, f))]  
        for file in onlyfiles:
            # transfer 10, mapping 51
            All_ListX4, acr_l1, with_l2, ProblemX4 = self.read_file_gene(STfile4+file, TransferSupport_HMGT, mapping, nodes) # return A_list, W_list, problem 
            across_withint_10_T34.extend(All_ListX4)
            prob.extend(ProblemX4)

        # remove duplicates
        across_withint_10_T34 = list(set(across_withint_10_T34)) 
        prob = list(set(prob)) 

        #get the list of transfer using transfer support t=100 and cost T =3
        across_withint_100_T4 = []
        
        onlyfiles = [f for f in listdir(STfile4) if isfile(join(STfile4, f))]  
        for file in onlyfiles:
            # transfer 100, mapping 51
            across_withint_100_T4, Across_List, Within_List, ProblemXX = self.read_file_gene(STfile4+file, TransferSupport_HGT, mapping, nodes) # return A_list, W_list, problem 
            across_withint_100_T4_full.extend(across_withint_100_T4)
            across_100_T4_full.extend(Across_List)
            withint_100_T4_full.extend(Within_List)
            
    
        #Read llist of high confidance HGTs, then get the  8 neighborhood genes around that transfer in the recipient genome
        ## if at least 3 of these neighborhood genes are transfer gene(check the genes with transfer cost 10 and T=3 and T4)
        #  or rare gene (check the full list that has old and missing rare genes including trees of size 3 )

        # all HGTs using transfer support 10 and transfer  cost 3 
        
        List_t10_T3_T4, List_t10_T3_T4_any = self.checkTransfer_donor(across_withint_10_T34) #donor+'>'+recip+'>'+gnF+'>'+RgName
        ###print
        #fileToCC = open('Transfers_Lists/Donor_prob_Int_1_immediate/T3_T4_t10.txt', "a+")
        #for bb in List_t10_T3_T4:
        #    fileToCC.write(bb+'\n')
        # list of all rare genes of size 1 and 2, and also the genes from gene trees of size 3
    
        rareGenes, rareGenes_any = self.checkTransfer_rare(RareFile) #donor>recipient>geneFam>RgeneName
        #List of the problem genes ProblemGenes_All.txt  donor>recipient>genefamily
        probleGenes, probleGenes_any = self.checkTransfer_problem(prob)  #donor+'>'+recip+'>'+gnF
        
        dict_FinalHGT = {}
        dict_allTransfers = {}
        for line1 in across_withint_100_T4_full: #across_withint_100_T4_full: #1234across_withint_100_T4_full: #across_100_T4_full change for across only or withint_100_T4_full within only results
            donor = line1.split(">")[0].strip()
            recipient = line1.split(">")[1].strip()
            geneFamily = line1.split(">")[2].strip()
            geneNameD = line1.split(">")[3].strip()
            geneNameR = line1.split(">")[4].strip()
            #transferGene = geneFamily+'_'+geneNameR
            keyC = recipient
            txxtF = donor+'>'+geneFamily+'>'+geneNameD+'>'+geneNameR
            if keyC in dict_allTransfers:
                dict_allTransfers[keyC].append(txxtF)
            else:
                dict_allTransfers[keyC] = []
                dict_allTransfers[keyC].append(txxtF)    

        ###Get all the reconciliation transfers 
        #Reconciliation3 = self.fill_Recon('RECON_T3.txt')
        #Reconciliation4 = self.fill_Recon('RECON_T4.txt')


        #print(allowed)      
        for keyT in dict_allTransfers: 
            RecipientGenomes = self.AllGenomes_lists_dict[keyT] #self.getGenomeList_ListOfLists(genomes+keyT+'.synteny')
            for trans in dict_allTransfers[keyT]:
                recipient = keyT
                donor = trans.split(">")[0].strip()
                geneFamily = trans.split(">")[1].strip()
                geneNameD = trans.split(">")[2].strip()
                geneNameR = trans.split(">")[3].strip()
                transferGene = geneFamily+'>'+geneNameR
                R_list = []
                for d_rr in RecipientGenomes:
                    if transferGene in d_rr:
                        R_list  = d_rr
                
                # get the neighborhood genes
                #EachSide = 4
                #NumberofImediat = 2 # --oo oo--

                DTransIndexF = R_list.index(transferGene) #(gfam+'_'+gNam)
                NeighborHoodGenes = self.getAroundList(int(EachSide), R_list, DTransIndexF) # get neighborhood genes (gfam+'_'+gNamD)
                
                genePosition = 1 # to specify the position of the gene neighborhood
                countHGT_imidiateNeig = 0
                countHGT_NOTimidiateNeig = 0
                countHGT = 0
                '''
                otherDonorsHGT = 0
                for geneN in NeighborHoodGenes:
                    if geneN != '0':
                        gnFamX = geneN.split('_')[0].strip()
                        gnNmX = geneN.split('_')[1].strip()
                        fullNameS = recipient+'>'+gnFamX+'>'+gnNmX
                        fullNameProbS = recipient+'>'+gnFamX
                        if (fullNameS in List_t10_T3_T4_any) or (fullNameS in rareGenes_any) or (fullNameProbS in probleGenes_any):
                            otherDonorsHGT = otherDonorsHGT +1
                if otherDonorsHGT < 3:
                '''
                for geneN in NeighborHoodGenes:
                    if geneN != '0':
                        gnFam = geneN.split('>')[0].strip()
                        gnNm = geneN.split('>')[1].strip()
                        
                        fullName = donor+'>'+recipient+'>'+gnFam+'>'+gnNm
                        fullNameZ = '0>'+recipient+'>'+gnFam+'>'+gnNm
                        fullNameProb = donor+'>'+recipient+'>'+gnFam
                        if (fullName in List_t10_T3_T4) or (fullName in rareGenes) or (fullNameZ in rareGenes) or (fullNameProb in probleGenes):
                        #if (fullNameProb in Reconciliation3) or (fullNameProb in Reconciliation4) or (fullName in List_t10_T3_T4) or (fullName in rareGenes) or (fullNameZ in rareGenes) or (fullNameProb in probleGenes):
                            countHGT = countHGT +1
                            #check if the neighborhood transfers is immidiate to the transer gene
                            if int(NumberofImediat) > 0:
                                if genePosition >=(int(EachSide)-int(NumberofImediat)+1) and genePosition <= (int(EachSide)+int(NumberofImediat)):
                                    countHGT_imidiateNeig = countHGT_imidiateNeig +1

                            #if genePosition <= (EachSide-NumberofImediat) or genePosition > (EachSide+NumberofImediat):
                            #    countHGT_NOTimidiateNeig = countHGT_NOTimidiateNeig +1
                            #elif genePosition >=(EachSide-NumberofImediat+1) and genePosition <= (EachSide+NumberofImediat):
                            #    countHGT_imidiateNeig = countHGT_imidiateNeig +1
                    genePosition = genePosition +1
                            #
                            #print(fullName, fullNameZ)
                
                if countHGT <= int(allowed):
                    #AsobriaCECT4245T_AveroniiBVH37:8022_2831_604
                    if countHGT_imidiateNeig == 0: #none of the immediate neighborhood genes should be a transfers from the same donor
                        key = donor+'>'+recipient
                        txxt = geneFamily+'>'+geneNameD+'>'+geneNameR
                        if key in dict_FinalHGT:
                            dict_FinalHGT[key].append(txxt)
                        else:
                            dict_FinalHGT[key] = []
                            dict_FinalHGT[key].append(txxt)    
        
        
            
        totalC = 0
        AllRunsFileTY=open(ToSaveFileX, "a")
        for keyx in dict_FinalHGT:
            txxt = keyx+':'
            for ee in dict_FinalHGT[keyx]:
                txxt = txxt + ee +','
            txxt = txxt[:-1]
            #print(txxt)#(keyx, ':', dict_FinalHGT[keyx]) 
            txxt = txxt + '\n'
            AllRunsFileTY.write(txxt)
        AllRunsFileTY.close()
            #totalC = totalC + len(dict_FinalHGT[keyx])      
        #print('Total HGT:', totalC) 
        #fileTo = open('ResultsNEW_Final_All_D/Across_results.txt', "a+")
        #fileTo.write('Total HGT: Across  '+str(allowed) +' : '+str(totalC)+'\n')


        '''
        #STfile = 'GeneTrees'
        #distFile = '0NEW_DART_MORE/AggregateRangerT4_MORE/'

        #/home/lik17005/2LINER_TestData/Results/0NEW_DART_MORE/AggregateRangerT3_More/
        ### get list of trees  
        TreeList = []
        with open('GeneTrees_More3.txt', "r") as f:
            for line in f:
                if not line.strip():#if there are an empty lines
                    continue
                else:
                    TreeList.append(line.strip())

        ## Copy aggregate files for the trees of size > 3
        STfile = 'AggregateRangerT4' #'AggregateRangerT3'
        distFile = '0NEW_DART_MORE/AggregateRangerT4_More/' #'0NEW_DART_MORE/AggregateRangerT3_More/'
        #Get list of trees that are of size > 3
        onlyfiles = [f for f in listdir(STfile) if isfile(join(STfile, f))]  
        for file in onlyfiles:
            if file in TreeList: 
                command = "cp "+STfile+'/'+file +" "+distFile
                os.system(command)  
        '''
        '''
        with open(self.species_tree, "r") as f:
                        try:
                            for line in f:
                                    if not line.strip():#if there are an empty lines
                                        continue
                                    else:
                                        species_tree = line #Read the species tree in a single line 
                                        self.species_tree = Tree(species_tree, format=1)
                    
        '''
        '''
        #Get list of trees that are of size > 3
        onlyfiles = [f for f in listdir(STfile) if isfile(join(STfile, f))]  
        for file in onlyfiles:
            with open(STfile+'/'+file, 'r') as f:
                    for line in f:
                        contC = line.count(',')
                        if contC != 2:
                            print(file)
                            #command = "cp "+STfile+'/'+file +" "+distFile
                            #os.system(command)  
        '''
if __name__ == "__main__":
   main(sys.argv[1:])
